"""
Django settings for bookstore_project project.

Generated by 'django-admin startproject' using Django 2.2.7.

For more information on this file, see
https://docs.djangoproject.com/en/2.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.2/ref/settings/
"""

import os

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY='l40smo4rcr*l(rae+k@bgiqo6=xh+qbu9k!it74j&v=iuko()9'
# SECRET_KEY = os.environ.get('SECRET_KEY')   # supplied by docker-compose.yml file.

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True
# DEBUG = int(os.environ.get("DEBUG", default=0))

ALLOWED_HOSTS = []


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',              # django's built-in auth app.
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'django.contrib.sites',             # new

    # Third party apps
    'crispy_forms',
    'allauth',                          # pip install django-allauth 
    'allauth.account',                  # 

    #Local Apps 
    'users.apps.UsersConfig',
    'pages.apps.PagesConfig',
    'books.apps.BooksConfig',
    'orders.apps.OrdersConfig',

]
from django.middleware import security
MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'bookstore_project.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, "templates")],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'bookstore_project.wsgi.application'


# Database
# https://docs.djangoproject.com/en/2.2/ref/settings/#databases
SQLITE = True

DATABASES = {}

if SQLITE:
    DATABASES['default']={'ENGINE':'django.db.backends.sqlite3',
            'NAME':os.path.join(BASE_DIR, 'db.sqlite3')}
else:
    DATABASES['default'] = { 'ENGINE': 'django.db.backends.postgresql',
            'NAME': 'postgres',
            'USER': 'postgres',
            'PASSWORD': 'postgres',
            'HOST': 'db',
            'PORT': 5432}


# Password validation
# https://docs.djangoproject.com/en/2.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/2.2/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/2.2/howto/static-files/

STATIC_URL          = '/static/'
STATICFILES_DIRS    = [os.path.join(BASE_DIR, "static"),]
STATIC_ROOT         = os.path.join(BASE_DIR, "staticfiles")
STATICFILES_FINDERS = [
    'django.contrib.staticfiles.finders.FileSystemFinder',      # looks in staticfiles_dirs
    'django.contrib.staticfiles.finders.AppDirectoriesFinder',  # looks in app level static directories
]
MEDIA_URL           = '/media/'
MEDIA_ROOT          = os.path.join(BASE_DIR, 'media')

AUTH_USER_MODEL = 'users.CustomUser'


CRISPY_TEMPLATE_PACK = 'bootstrap4'


# Start django-allauth config
SITE_ID = 1                         # django-allauth uses sites framework of django
LOGIN_REDIRECT_URL = "pages:home"
# LOGOUT_REDIRECT_URL = "login"     # django-allauth overrides this property.
ACCOUNT_LOGOUT_REDIRECT = "login"   # Provided by django-allauth, it overrides the django's default LOGOUT_REDIRECT_URL.

ACCOUNT_SESSION_REMEMBER            = True     # Rember Me , set to True in login page.
ACCOUNT_SIGNUP_PASSWORD_ENTER_TWICE = False
ACCOUNT_USERNAME_REQUIRED           = False
ACCOUNT_AUTHENTICATION_METHOD       = 'email'
ACCOUNT_EMAIL_REQUIRED              = True
ACCOUNT_UNIQUE_EMAIL                = True

DEFAULT_FROM_EMAIL = 'admin@djangobookstore.com'        # email to use when sending email in signup confirmation.

# Authentication backends
AUTHENTICATION_BACKENDS = (
    'django.contrib.auth.backends.ModelBackend',                # by default
    'allauth.account.auth_backends.AuthenticationBackend',
)

# End of django-allauth config


# Start email configuration
EMAIL_BACKEND = 'django.core.mail.backends.console.EmailBackend'                # To send mails to console.
# EMAIL_BACKEND           = 'django.core.mail.backends.smtp.EmailBackend'           # To send mails to Email.
# EMAIL_HOST              = 'smtp.sendgrid.net'
# EMAIL_HOST_USER         = 'apikey'
# EMAIL_HOST_PASSWORD     = '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'
# EMAIL_PORT              = 587
# EMAIL_USE_TLS           = True
# email configuration ends here.


# Stripe payment config start

# STRIPE_TEST_PUBLISHABLE_KEY = os.environ.get('STRIPE_TEST_PUBLISHABLE_KEY')
# STRIPE_TEST_SECRET_KEY = os.environ.get('STRIPE_TEST_SECRET_KEY')

STRIPE_TEST_PUBLISHABLE_KEY = 'pk_test_J5EVxhqBYAfSUIZ01xjQQCfW001RQkltRz'
STRIPE_TEST_SECRET_KEY = 'sk_test_OUxUUSD1ZSzDLt4Q5VMVtrfJ00Fsr3E0B0'
# stripe payment config end